export const createOptions = (variableValue, expectedType, receivedType) => {
    const parsed = variableValue;
    const parseAble = receivedType === expectedType;
    return {
        /**
         *
         * @param u the value to return if the data type does not match and have failed to parse
         * @returns
         */
        orElse: (u) => {
            return parseAble ? parsed : u;
        },
        /**
         *
         * @param variableName name of the variable. So that when parsing is not possible, you will know which parsing of variable have failed
         * @returns
         */
        orElseThrowError: (variableName) => {
            if (parseAble) {
                return parsed;
            }
            throw new ParseError(variableName, variableValue, expectedType, receivedType);
        },
    };
};
class ParseError extends Error {
    constructor(variableName, variableValue, expectedType, receivedType) {
        super(`Command of ${variableName}: "${variableValue}" given is not of type ${expectedType}, instead it is ${receivedType}`);
    }
}
//# sourceMappingURL=parseAsType.js.map